'____________________________________________________________________________________
'File         FileRegManager11.vbs
'Author       verloc
'Feedback     verloc2000@yahoo.it
'
'Description  Installa/Disinstalla files registro.
'
'History      Versione Beta1       11/04/2001
'             
'             Versione 1.0         24/04/2001
'   
'             Versione 1.1         3/05/2001
'
'
'Disclaimer   L'autore di FileRegManager non si assume alcuna responsabilit riguardo
'             eventuali malfunzionamenti o danni dovuti all'uso proprio o improprio 
'             dello script.
'             FileRegManager pu essere legalmente e liberamente distribuito a
'             condizione che ci avvenga gratuitamente e mantenendo l'integrit del file
'             in ogni sua parte.
'             La pubblicazione di FileRegManager su supporto cartaceo,digitale o
'             su Internet pu avvenire solo dopo esplicito consenso dell'autore.
'____________________________________________________________________________________


Dim fso,wsh
Set fso = CreateObject("Scripting.FileSystemObject")  
Set wsh = WScript.CreateObject("WScript.Shell")

Dim f,ts,LengKey,StrFileName,StrOnlyFileName,StrPathName,StrAllFile,uno,KeyName,Key,LenReadAll
Dim Number,Pos(),Resto(),PosRel(),Keys()


Const ForReading = 1, ForWriting = 2, ForAppending = 3 
Const WARNING_Texta= "Il file selezinato  inesistente"
Const WARNING_Textb= "Il file  stato gi installato"
 
Const WARNING_Textd="Il file "
Const WARNING_Texte=" non  stato ancora installato"
Const WARNING_Textf="Il file selezionato non  un file registro"

 HEADER_Text=   "FileRegManager  1.1"
 
 WELCOME_Texta= " "&vbcrlf&vbcrlf&vbcrlf _
                &"        FileRegManager.vbs       "&" Copyright "&Chr(169)&vbcrlf&vbcrlf _
                &"                         by  verloc                         "&vbcrlf&vbcrlf _
                &"                verloc2000@yahoo.it           "&vbcrlf&vbcrlf _
                &"FRM consente  di  installare/disinstallare  files" &vbcrlf _
                &"registro in sicurezza effettuando un backup delle         "&vbcrlf _
                &"impostazioni precedenti."&vbcrlf&vbcrlf _
                &"Assicurarsi che FRM sia copiato e lanciato"&vbcrlf _
                &"da una cartella contenente files registro (.reg)."&vbcrlf&vbcrlf _
                &"Continuare ?"&vbcrlf&vbcrlf _
                     
 WELCOME_Textb= HEADER_Text&vbcrlf&vbcrlf _
                &"Vuoi installare "
                    
 WELCOME_Textc= HEADER_Text&vbcrlf&vbcrlf _
                &"Vuoi disinstallare "
                
 WELCOME_textg= "un file nel registro                       "&vbcrlf _
                     &"di configurazione?"
 
 WARNING_Texth= "Selezionare un file"
                    
 INST_Texta   = "Install"&vbcrlf&vbcrlf _
                &"Inserisci il nome del file registro da installare"&vbcrlf _
                &"completo di estensione  (.reg)"&vbcrlf&vbcrlf _
                &"Esempio:       mio_file.reg"
                
 UNINST_Text  = "Uninstall"&vbcrlf&vbcrlf _
                &"Inserisci il nome del file registro da disinstallare"&vbcrlf _
                &"completo di estensione  (.reg)"&vbcrlf&vbcrlf _
                &"Esempio:       mio_file.reg"


Dim Temp,WshSysEnv
Set WshSysEnv = Wsh.Environment("Process")
Temp=WshSysEnv("Temp")

Call Welcome(WELCOME_Texta)
Call WelcomeInst()
Call WelcomeUninst()
Set fso=Nothing
Set wsh=Nothing
Set WshSysEnv=Nothing

'-----------------Functions----------------------------------------------

Function GetPath                        ' Restituisce il percorso dello script
                                       
DIM path
path = wscript.ScriptFullName  ' nome dello script
GetPath = Left(path, InstrRev(path, "\"))
End Function

Function stringminusFour(string)        'restituisce il nome del file privo di estensione
      stringminusFour=Mid(string,1,Len(string)-4)
End Function
'-------------------------------------------------------------------------

Sub Chiave(StrPathName)             'Estrae dal file registro le chiavi contenute
                                    
Set f = fso.GetFile(StrPathName)          
Set ts = f.OpenAsTextStream(ForReading)
StrAllFile=ts.ReadAll
StrAllFile=CStr(StrAllFile)
LenReadAll=Len(StrAllFile)
'wsh.Popup StrAllFile,4,HEADER_Text       'mostra il file per 4 secondi e continua 
uno="[HKEY_"
due="]"
Number=-1
For i = 1 To LenReadAll Step 1
 If Mid(StrAllFile,i,6)=uno Then Number=Number+1  : ReDim Preserve Pos(Number):Pos(Number)=i _
 :ReDim Preserve Resto(Number):Resto(Number)=CStr(Mid(StrAllFile,i)) _
 :ReDim Preserve PosRel(Number):  PosRel(Number)=InStr(1,Resto(Number),due) _
 :Redim Preserve Keys(Number):  Keys(Number)=CStr(Mid(StrAllFile,Pos(Number)+1,PosRel(Number)-2))     
Next

End Sub

'-----------------Subroutines-----------------------------------------------

Sub Welcome(WELCOME_TEXT)
Dim intDoIt
   
    intDoIt =  MsgBox(WELCOME_TEXT,    _   
                      vbYesNo + vbInformation,       _
                      HEADER_Text )
    If intDoIt = vbNo Then WScript.Quit
        
End Sub
'-----------------------------------------------------------------------------

Sub WelcomeInst()
    intDoIt =  MsgBox(WELCOME_Textb&WELCOME_Textg,    _   
                      vbYesNo + vbInformation,       _
                      HEADER_Text )
    If intDoIt = vbYes Then Call Install
        
End Sub
'----------------------------------------------------------------------------

Sub WelcomeUninst()
    intDoIt =  MsgBox(WELCOME_Textc&WELCOME_Textg,    _   
                      vbYesNo + vbInformation,       _
                      HEADER_Text )
    If intDoIt = vbYes Then Call Uninstall Else WScript.Quit 
        
End Sub
'-----------------------------------------------------------------------------

Sub Warning(WARNING_Text)
    Dim intDoIt
   
    intDoIt =  MsgBox(WARNING_Text,    _   
                      vbOKOnly + vbExclamation,       _
                      HEADER_Text )
    If intDoIt = vbOKOnly Then WScript.Quit
        
End Sub
'----------------------------------------------------------------------------

Sub Install()

 StrFileName=InputBox(INST_Texta,HEADER_Text)
 StrFileName=CStr(StrFileName)
 If StrFileName="" or Null Then  Warning(WARNING_Texth):WScript.Quit
 StrOnlyFileName=stringminusFour(StrFileName)
If not fso.FileExists(Getpath&StrFileName) Then Warning(WARNING_Texta):WScript.Quit
If fso.GetExtensionName(Getpath&StrFileName)<>"reg" Then Warning(WARNING_Textf):WScript.Quit 
StrPathName=GetPath&StrFileName 
Chiave(StrPathName)
If not fso.FolderExists(Getpath&StrOnlyFileName) Then fso.CreateFolder(Getpath&StrOnlyFileName) Else Warning(WARNING_Textb):WScript.Quit

Call ExportTemp("old_")
Call CreateBak("old_")
Call DeleteFileInString("old_",Temp)
wsh.Run "Regedit /s "&""""&StrPathName&""""
Call ExportTemp("now_")
Call CreateBak("now_")
Call DeleteFileInString("now_",Temp)

End Sub
'---------------------------------------------------------------------------------

Sub Uninstall
Dim StrFileName 
 StrFileName=InputBox(UNINST_Text,HEADER_Text)
 StrFileName=CStr(StrFileName)
 If StrFileName="" or Null Then  Warning(WARNING_Texth):WScript.Quit
 StrOnlyFileName=stringminusFour(StrFileName) 
If not fso.FileExists(Getpath&StrFileName) Then Warning(WARNING_Texta):WScript.Quit
If not fso.FolderExists(Getpath&StrOnlyFileName) Then Warning(WARNING_Textd&StrFileName&WARNING_Texte):WScript.Quit
StrPathName=GetPath&StrFileName
Chiave(StrPathName)

On Error Resume Next
For i=0 To Number
wsh.RegDelete(Keys(i)&"\")
Next
r=CStr(GetPath)
StrExp=r&StrOnlyFileName&"\"&"old_"&StrFileName
If  fso.FileExists(StrExp) Then wsh.Run "Regedit /s "&""""&StrExp&""""
fso.DeleteFolder(Getpath&StrOnlyFileName)
End Sub
'----------------------------------------------------------------------------

Sub ExportTemp(stri)             'Esporta le impostazioni precedenti all'installazione
                                 'in file temporanei
For i=0 To Number
    StrExp="%temp%"&"\"&stri&i&StrFileName
    wsh.Run "Regedit /e "&""""&StrExp&""""&""""&Keys(i)&""""
Next
End Sub
'----------------------------------------------------------------------------

Sub CreateBak(stri)             'Controlla l'esistenza delle chiavi contenute
                                'nel file registro rilevando la presenza dei files 
                                'temporanei ed eventualmente le riunisce in un unico file di backup

If fso.FileExists(Temp&"\"&stri&"0"&StrFileName) Then CreateFiles(stri)
End Sub
'----------------------------------------------------------------------------

Sub CreateFiles(stri)           'crea il backup preponendo stri al nome del file

fso.CreateTextFile(Getpath&StrOnlyFileName&"\"&stri&StrFileName)
Set g=fso.GetFile(Getpath&StrOnlyFileName&"\"&stri&StrFileName) 
set ff=g.OpenAsTextStream(ForWriting)
 
Set registri=fso.GetFolder(Temp)
Set fileregtemp=registri.Files
For Each file in fileregtemp
  N=file.name
  If Mid(N,1,4)=stri then Set cic=fso.GetFile(Temp&"\"&N) _
     :set pof=cic.OpenAsTextStream(ForReading) _
     :todo=pof.ReadAll _
     :ff.Write(todo) _
     :pof.Close  
Next
ff.Close
End Sub     
'----------------------------------------------------------------------------

Sub DeleteFileInString(stri,Fol)     'Cancella dalla cartella Fol i file temporanei 
                                     'che iniziano per stri(stringa di 4 caratteri)
Set OneFol=fso.GetFolder(Fol)        
Set AllFls=OneFol.Files
For Each file in AllFls
N=file.name
If Mid(N,1,4)=stri then fso.DeleteFile(Fol&"\"&N)
Next
End Sub
'----------------------------------------------------------------------------